package fbg.gui;

// Title:       Graphical User Interface
// Version:     2.0
// Copyright:   1999
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

import java.awt.Component;
import java.awt.Cursor;

import javax.swing.UIManager;

// Interfaz grfica de usuario
// ---------------------------

// v1.0 Jan'99 JDK 1.1 & SWING 1.0.1
// v2.0 Jan'99 JDK 1.2

public class GUI
{

  // Cursor

  public static void setDefaultCursor (Component component)
  {
    Cursor cursor = Cursor.getDefaultCursor();

    component.setCursor(cursor);
  }

  public static void setWaitCursor (Component component)
  {
    Cursor waitCursor = Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR);

    component.setCursor(waitCursor);
  }

  // Look & Feel

  public static final byte   SYSTEM        = 0;
  public static final byte   CROSSPLATFORM = 1;
  public static final byte   METALWORKS    = 2;
  public static final byte   MOTIF         = 3;
  public static final byte   WINDOWS       = 4;
  public static final byte   MAC           = 5; // No estndar
  public static final byte   ORGANIC       = 6; // Feo

  public static final String SWING1 = "com.sun.java.swing.";
  public static final String SWING2 = "javax.swing.";


  public static void Look (byte estilo)
  {
    try {

        switch (estilo) {

          case METALWORKS:
               // Metal Look & Feel
               UIManager.setLookAndFeel(SWING2+"plaf.metal.MetalLookAndFeel");
               break;
              
          case MOTIF:
               // MOTIF L&F
               UIManager.setLookAndFeel(SWING1+"plaf.motif.MotifLookAndFeel");
               break;

          case WINDOWS:
               // MS Windows L&F
               UIManager.setLookAndFeel(SWING1+"plaf.windows.WindowsLookAndFeel");
               break;

          case MAC:
               // Mac
               UIManager.setLookAndFeel(SWING1+"plaf.mac.MacLookAndFeel");
               break;

          case ORGANIC:
               // Organic
               UIManager.setLookAndFeel(SWING1+"plaf.organic.OrganicLookAndFeel");
               break;

          case CROSSPLATFORM:
               // Cross Platform L&F
               UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
               break;

         case SYSTEM:
         default:
               // System L&F
               UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }

    } catch (Exception e) {
        System.err.println("L&F Error: " + e);
    }
  } 

}
