package fbg.gui;

// Title:       XYLayout manager
// Version:     1.0
// Copyright:   1998
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

public class XYConstraints implements Cloneable, java.io.Serializable
{
  int x;
  int y;

  int width;
  int height;

  // Constructores

  public XYConstraints()
  {
    this(0, 0, 0, 0);
  }

  public XYConstraints (int x, int y, int width, int height)
  {
    this.x = x;
    this.y = y;
    this.width = width;
    this.height = height;
  }

  // Acceso a las variables de instancia

  public int getX ()
  {
    return x;
  }

  public void setX (int x)
  {
    this.x = x;
  }

  public int getY()
  {
    return y;
  }

  public void setY (int y)
  {
    this.y = y;
  }

  public int getWidth()
  {
    return width;
  }

  public void setWidth (int width)
  {
    this.width = width;
  }

  public int getHeight ()
  {
    return height;
  }

  public void setHeight (int height)
  {
    this.height = height;
  }

  // Hashing

  public int hashCode()
  {
    return x ^ (y*37) ^ (width*43) ^ (height*47);
  }

  // Comparacin

  public boolean equals (Object that)
  {
    if (that instanceof XYConstraints) {

       XYConstraints other = (XYConstraints)that;

       return other.x == x
           && other.y == y
           && other.width == width
           && other.height == height;
    }

    return false;
  }

  // Clnico

  public Object clone()
  {
    return new XYConstraints (x, y, width, height);
  }

  // String

  public String toString()
  {
    return "XYConstraints[" + x + "," + y + "," + width + "," + height + "]";
  }

}
