package fbg.gui.html;

// Title:       HTML Frame
// Version:     2.2
// Copyright:   1999
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

import java.awt.*;
import java.awt.event.*;

import javax.swing.JFrame;

import java.net.URL;

import fbg.gui.GUI;

import fbg.util.Loader;

// v1.0: Oct'98 JDK 1.1 & SWING 1.0.1
// v1.1: Ene'99 Navegacin
// v2.0: Ene'99 JDK 1.2
// v2.1: Mar'99 URLs
// v2.2: Jun'99 Icono

public class HTMLFrame extends    JFrame
                       implements LayoutManager
{
  HTML html = null;

  // Constructors

  public HTMLFrame (String title, String ruta)
  {
    Image icon = Loader.loadImage(getClass(),"html.gif");

    setIconImage(icon);
    setTitle(title);

    html = new HTML(ruta);

    addWindowListener(new HTMLWindowAdapter());
    setBackground(Color.lightGray);
    getContentPane().add(html);
    pack();

    // this.setResizable(false);

    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((d.width - def.width)/2, (d.height - def.height)/2, 640,480);
  }

  public HTMLFrame (String title, URL ruta)
  {
    setTitle(title);

    html = new HTML(ruta);

    addWindowListener(new HTMLWindowAdapter());
    setBackground(Color.lightGray);
    getContentPane().add(html);
    pack();

    // this.setResizable(false);

    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((d.width - def.width)/2, (d.height - def.height)/2, 640,480);
  }

  // Navigation

  public void jump (String ruta)
  {
    html.set (ruta);
  }

  public void jump (URL ruta)
  {
    html.set (ruta);
  }

  public void setHome (String ruta)
  {
    html.reset (ruta);
  }

  public void setHome (URL ruta)
  {
    html.reset (ruta);
  }

  // Events

  class HTMLWindowAdapter extends java.awt.event.WindowAdapter
  {
    public void windowClosing (WindowEvent e)
    {
      end();
    }
  }

  public void end ()
  {
    if (navegador)
       System.exit(0);
    else
       setVisible(false);
  }

  // LAYOUT

  private int inset = 5;

  private Dimension min = new Dimension(250,200);
  private Dimension def = new Dimension(640,480);

  public Dimension preferredLayoutSize (Container c)
  {
    return def;
  }

  public Dimension minimumLayoutSize (Container c)
  {
    return min;
  }

  public void addLayoutComponent (String s, Component c)
  {
  }

  public void removeLayoutComponent(Component c)
  {
  }

  public void layoutContainer(Container c)
  {
    Rectangle b = c.getBounds();

    html.setBounds ( inset,
                     inset,
                     b.width-2*inset,
                     b.height-2*inset);
  }

  // Stand-alone application

  boolean navegador = false;

  public static void main (String args[])
  {

    if (args.length != 1) {
       System.err.println("Sintaxis:");
       System.err.println("java fbg.gui.HTMLFrame fichero");
       return;
    }

    GUI.Look (GUI.SYSTEM);

    HTMLFrame frame = new HTMLFrame("Navegador HTML",args[0]);

    frame.navegador = true;
    frame.setVisible(true);
  }
}
