package fbg.gui.monitor;

// Title:       SWING Memory Monitor
// Version:     1.0
// Copyright:   June 1999
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

import java.awt.*;
import java.awt.event.*;
import fbg.gui.*;

import fbg.util.Environment;
import fbg.util.Loader;

public class MemoryMonitorFrame extends Frame
{
  XYLayout      xyLayout = new XYLayout();
  MemoryMonitor monitor  = null;
  Button        buttonOK = new Button();

  // Constructor

  public MemoryMonitorFrame ()
  {
    String label;
    Image  icon = Loader.loadImage(getClass(),"monitor.gif");

    if (Environment.settings!=Environment.SPANISH) {
       this.setTitle("Memory Use");
       label = "Memory Monitor";
    } else {
       this.setTitle("Uso de memoria");
       label = "Monitor de memoria";
    }

    monitor = new MemoryMonitor(label);

    xyLayout.setHeight(225);
    xyLayout.setWidth(325);

    this.setBackground(Color.lightGray);
    this.setSize( new Dimension(325,225));
    this.setLayout(xyLayout);
    this.setIconImage(icon);
    this.addWindowListener(new MemoryMonitorFrame_windowAdapter(this));

    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new MemoryMonitorFrame_buttonAdapter(this));

    this.add(monitor,  new XYConstraints( 10,  10, 300, 150));
    this.add(buttonOK, new XYConstraints(110, 165, 100,  25));
  }

  // Events

  void close ()
  {
    dispose();
  }

  void stop ()
  {
    monitor.mc.stop();
  }

  void start ()
  {
    monitor.mc.start();
  }

  // TEST

  public static void main (String s[]) 
  {
    MemoryMonitorFrame demo = new MemoryMonitorFrame();

    demo.show();
  }
}

// Event handlers
// --------------

class MemoryMonitorFrame_buttonAdapter implements java.awt.event.ActionListener
{
 MemoryMonitorFrame adaptee;

 MemoryMonitorFrame_buttonAdapter(MemoryMonitorFrame adaptee)
 {
   this.adaptee = adaptee;
 }

 public void actionPerformed(ActionEvent e)
 {
   adaptee.close();
 }
}

class MemoryMonitorFrame_windowAdapter extends java.awt.event.WindowAdapter
{
  MemoryMonitorFrame adaptee;

  MemoryMonitorFrame_windowAdapter(MemoryMonitorFrame adaptee)
  {
    this.adaptee = adaptee;
  }

  public void windowClosing(WindowEvent e)
  {
    adaptee.close();
  }
	 
  public void windowDeiconified(WindowEvent e) 
  { 
    adaptee.start(); 
  }
	   
  public void windowIconified(WindowEvent e) 
  { 
    adaptee.stop(); 
  }
}

