package fbg.jdbc.client;

// Title:       JDBC Server
// Version:     1.0
// Copyright:   February 1999
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

import java.io.*;
import java.net.*;
import java.lang.*;

import fbg.jdbc.server.Protocol;


public class Client
{

  public static void main (String[] args) throws IOException 
  {
    Link    link;
    String  tmp;
    String  host = "PCStar.Granada";
    int     port = 6666;
    boolean fin  = false;

    BufferedReader input = new BufferedReader(new InputStreamReader(System.in));


    if (args.length!=2) {
       System.out.println("Sintaxis: java fbg.jdbc.client.Client <host> <port>");
    }

    host = args[0];
    port = Integer.parseInt(args[1]);

    try {
    
        link = new Link(host,port);
    
        System.out.println("C: Esperando respuesta del servidor...");

        tmp = link.receive(); // Protocol.INIT
        
        while (!tmp.equals("")){
              System.out.println("S: "+tmp);
              tmp = link.receive();
        }

        do {

           do {
              System.out.print("C: ");
              tmp = input.readLine();
              link.send(tmp+"\n");
           } while (!tmp.equals(""));

           tmp = link.receive();

           if (tmp.equals(Protocol.CLOSE)) 
              fin = true;
        
           while (!tmp.equals("")){
                 System.out.println("S: "+tmp);
                 tmp = link.receive();
           }

        } while (!fin);

    } catch (UnknownHostException e) {
        System.err.println("Unknown host: "+host);
    } catch (IOException e) {
        System.err.println("Couldn't get I/O for the connection to "+host);
    } catch (Exception e) {
        System.err.println("Error: "+e.toString());
    }
  }
}

