package fbg.jdbc.client;

// Title:       JDBC Server
// Version:     1.0
// Copyright:   February 1999
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

import java.io.*;
import java.net.*;
import java.lang.*;

import fbg.jdbc.server.Protocol;

// Enlace con el servidor

public class Link
{
  Socket  socket = null;

  // private PrintStream out;     // JDK 1.0
  // private DataInputStream in;
  
  private PrintWriter    out;     // JDK 1.1
  private BufferedReader in;

  // Constructor
  
  public Link (String server, int port)
         throws UnknownHostException, IOException
  {
    socket = new Socket(server,port);
    
    // out = new PrintStream(socket.getOutputStream());       // 1.0
    // in  = new DataInputStream(socket.getInputStream());
    
    out = new PrintWriter(socket.getOutputStream(), true);    // 1.1
    in  = new BufferedReader(new InputStreamReader(socket.getInputStream()));
  }

  // Enviar datos al servidor

  public void send (String cadena) throws IOException
  {
    out.print(cadena);
    out.flush();
  }

  // Recibir datos cuando el servidor est disponible (JDK 1.1)

  // public String receive() throws IOException
  // {
  //   if (in.ready())
  //     return in.readLine();
  //   else
  //     return null;
  // }

  // Espera indefinida (JDK 1.0)

  public String receive() throws IOException
  {
    return in.readLine();
  }

  // Finalizador

  protected void finalize() throws Exception
  {
    // send( Protocol.CLOSE + "\n\n");
    out.close();
    in.close();
    socket.close();
  }
  
}