package fbg.jdbc.server;

// Title:       JDBC Server
// Version:     1.0
// Copyright:   February 1999
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

import java.io.*;
import java.net.*;

// Escucha las peticiones de los clientes 
// y crea las hebras en que son atendidas


public class Server 
{
  static final int ESCAPE=27;

  ServerSocket serverSocket = null;

  // Pone en marcha el servidor, que atiende las peticiones
  // recibidas por el puerto indicado

  public void run (int puerto)
  {
    // Configuracin del puerto

    try {
        serverSocket = new ServerSocket((int)puerto);
    } catch (IOException e) {
        System.err.println("No se pueden atender peticiones por el puerto "+puerto);
        System.exit(-1);
    }

    // Bucle de escucha

    System.out.println("Servidor en marcha...");

    while (true)
          try{
            new ServerThread(serverSocket.accept()).start();
          }catch(Exception e){
            System.out.println("Error al capturar peticin");
          }


    // Finalizacin:
    // serverSocket.close();
  }

  // Programa principal

  public static void main (String[] args) throws IOException 
  {
    Server server = new Server();
    int    port;

    // Sintaxis
       
    if (args.length!=1){
       System.err.println("Sintaxis: java fbg.jdbc.server.Server <puerto>");
       System.exit(-1);
    }

    port = Integer.parseInt(args[0]);

    if ((port>65535) || (port<0)) {
       System.err.println ("Puerto incorrecto"); 
       System.exit(-1);
    }

    server.run(port);
  }
}
