/* ------------------------------------------------------------- */
/*    Fernando Berzal Galiano       ETS Ingeniera Informtica   */
/* ------------------------------------------------------------- */
/*                         TDA  Bosque                           */
/* ------------------------------------------------------------- */

package fbg.tda;


public class ArbolBinario extends Arbol
{
  public ArbolBinario ()
  {
    super();
  }

  public NodoArbol HijoIzquierda (NodoArbol nodo, Object dato)
  {
    return Hijo (nodo,dato);
  }

  public NodoArbol HijoDerecha (NodoArbol nodo, Object dato)
  {
    return Hermano (nodo,dato);
  }

  // Listados de un rbol binario
  // ----------------------------
  
  // PREORDEN (rbol binario)
 
  private void PreOrden (NodoArbol nodo, Lista lista)
  {
    if (nodo!=null) {
       lista.Insertar(lista.Fin(), nodo.info);
       PreOrden (nodo.HijoIzquierda(), lista);
       PreOrden (nodo.HijoDerecha(), lista);
    }
  }

  Lista PreOrden ()
  {
    Lista lista = new Lista ();

    PreOrden ( Raiz(), lista);

    return lista;
  }

  // INORDEN (rbol binario)
  
  private void InOrden (NodoArbol nodo, Lista lista)
  {
    if (nodo!=null) {
       InOrden (nodo.HijoIzquierda(), lista);
       lista.Insertar (lista.Fin(), nodo.info);
       InOrden (nodo.HijoDerecha(), lista);
    }
  }

  Lista InOrden ()
  {
    Lista lista = new Lista();

    InOrden ( Raiz(), lista);
    
    return lista;
  }

  // POSTORDEN (rbol binario)

  private void PostOrden (NodoArbol nodo, Lista lista)
  {
    if (nodo!=null) {
       PostOrden (nodo.HijoIzquierda(), lista);
       PostOrden (nodo.HijoDerecha(), lista);
       lista.Insertar (lista.Fin(), nodo.info);
    }
  }

  Lista PostOrden ()
  { 
    Lista lista = new Lista();
 
    PostOrden (Raiz(), lista);

    return lista;
  }

  // Listado por niveles (rbol binario)

  public Lista PorNiveles ()
  {
    NodoArbol nodo  = Raiz ();
    Lista     lista = new Lista ();
    Cola      cola  = new Cola ();

    cola.Encolar (nodo);

    while (!cola.Vacia()) {

      	  nodo = (NodoArbol) cola.Extraer ();

          if (nodo!=null) {
	     lista.Insertar ( lista.Fin(), nodo.info );
	     cola.Encolar ( nodo.HijoIzquierda() );
	     cola.Encolar ( nodo.HijoDerecha() );
	  } else
	     lista.Insertar ( lista.Fin(), null);
    }

    return lista;
  }

  // Constructor a partir de un listado por niveles (rbol binario)

  public ArbolBinario (Lista l)
  {
    super();   // Llama al constructor habitual de un rbol

    Cola      cola = new Cola();
    Object    dato;
    NodoLista nodo_lista;
    NodoArbol nodo_arbol;

    /* Raz del rbol binario */

    nodo_lista = l.Inicio();
    dato       = l.Leer(nodo_lista);

    if (dato!=null) {
       nodo_arbol = Raiz ( dato );
       cola.Encolar ( nodo_arbol );
    }
  
    /* Resto de los nodos */

    while (!cola.Vacia()) {
	  nodo_arbol = (NodoArbol) cola.Extraer ();
          nodo_lista = l.Siguiente ( nodo_lista );
	  dato = l.Leer ( nodo_lista );

	  if (dato!=null) 
	     cola.Encolar ( HijoIzquierda(nodo_arbol,dato) );

	  nodo_lista = l.Siguiente ( nodo_lista );
	  dato = l.Leer ( nodo_lista );

	  if (dato!=null)
	     cola.Encolar ( HijoDerecha(nodo_arbol,dato) );
    }
  }


}

/* ------------------------------------------------------------- */
