/* ------------------------------------------------------------- */
/*    Fernando Berzal Galiano       ETS Ingeniera Informtica   */
/* ------------------------------------------------------------- */
/*                  TDA Lista doblemente enlazada                */
/* ------------------------------------------------------------- */

package fbg.tda;


public class Lista
{
  private NodoLista cabecera;

  private int size;

  // Constructor

  public Lista ()
  {
    size = 0;

    cabecera = new NodoLista();

    if (cabecera!=null) {
       cabecera.anterior  = cabecera;
       cabecera.siguiente = cabecera;
    }
  }


  public int Elementos ()
  {
    return size;
  }

  public boolean Vacia ()
  {
    return (size==0);
    // return (cabecera.anterior==cabecera);
    // return (cabecera.siguiente==cabecera);
  }

  public NodoLista Inicio ()
  {
    return cabecera;
  }
   
  public NodoLista Ultimo ()
  {
    return cabecera.anterior.anterior;
  }

  public NodoLista Fin ()
  {
    return cabecera.anterior;
  }

  public void Borrar (NodoLista nodo)
  {
    NodoLista aux = nodo.siguiente;
 
    if (nodo!=Fin()) {
       nodo.siguiente = nodo.siguiente.siguiente;
       nodo.siguiente.anterior = nodo; 
       size--;
    } 
  }  

  public boolean Insertar (NodoLista nodo, Object dato)
  {
    NodoLista nuevo = new NodoLista(dato);

    if (nuevo!=null) {
       nuevo.siguiente = nodo.siguiente;
       nuevo.anterior  = nodo;
       nuevo.anterior.siguiente = nuevo;
       nuevo.siguiente.anterior = nuevo; 
       size++;
    }     

    return (nuevo!=null);
  }

  public Object Leer (NodoLista nodo)
  {
    if (nodo!=Fin())
       return nodo.siguiente.info;
    else
       return null;
  }


  public NodoLista Siguiente (NodoLista nodo)
  {
    if (nodo!=Fin())
       return nodo.siguiente;
    else
       return null;
  } 

  public NodoLista SiguienteCircular (NodoLista nodo)
  {
    if (nodo!=Ultimo())
       return Siguiente(nodo);
    else
       return Inicio();
  }

  public NodoLista Anterior (NodoLista nodo)
  {
    if (nodo!=Inicio())
       return nodo.anterior;
    else
       return null;
  } 

  public NodoLista AnteriorCircular (NodoLista nodo)
  {
    if (nodo!=Inicio())
       return Anterior(nodo);
    else
       return Ultimo();
  }

}

