package fbg.util;

// Title:       Text ADT
// Version:     1.1
// Copyright:   1999
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

import java.io.File;
import java.io.RandomAccessFile;
import java.io.IOException;

import java.util.Vector;

// v1.0 '98 Spanish IDs
// v1.1 '99 English IDs

public class Text
{
  Vector lines;

  // Constructor

  public Text ()
  {
    lines = new Vector();
  }

  // Acceso a las lneas del texto: de 0 a N-1

  public int totalLines ()
  {
    return lines.size();
  }

  public String line (int n)
  {
    return (String)lines.elementAt(n);
  }

  // Modificacin del texto

  public void insertLine (int n, String s)
  {
    lines.insertElementAt(s,n);
  }

  public void appendLine (String s)
  {
    lines.addElement(s);
  }

  public void removeLine (int n)
  {
    lines.removeElementAt(n);
  }

  public void removeLine (String s)
  {
    lines.removeElement(s);
  }


  // E/S
  // ---

  // Carga el texto desde un fichero

  public Text (String fichero)
  {
    this();

    // Lectura

    RandomAccessFile f;

    try {

       f = new RandomAccessFile(fichero, "r");

       while (f.getFilePointer() < f.length())
             this.appendLine(f.readLine());

       f.close();

    } catch (IOException e) {

       // System.out.println("Error: " + e.toString());

    }
  }

  // Guarda el texto en un fichero

  public void save (String fichero)
  {
    int              i;
    File             d;
    RandomAccessFile f;

    try {

       d = new File(fichero);

       d.delete(); // Si el fichero ya existe, se elimina

       f = new RandomAccessFile(d, "rw");

       for (i=0; i<lines.size(); i++)
           f.writeBytes(this.line(i)+"\n");

       f.close();

    } catch (IOException e) {

       // System.out.println("Error: " + e.toString());

    }
  }

}

