package fbg.util.db;

// Title:       TMiner
// Version:     1.2
// Copyright:   1999
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

import fbg.tda.Lista;

// CampoCHAR
// ---------

// Versin 1.0: Ago'98 Modelizacin de campos de tipo categrico (CHAR)
// Versin 1.1: May'99 Longitud variable o desconocida (-1)
// Versin 1.2: Jun'99 Campo 1.1


public class CampoCHAR extends Campo
{
  int longitud;

  // Constructor

  public CampoCHAR (Tabla tabla, String nombre)
  {
    super (tabla, nombre);
    longitud = -1;
  }

  public CampoCHAR (Tabla tabla, String nombre, int length)
  {
    super (tabla, nombre);
    longitud = length;
  }

  // Longitud

  public int Longitud ()
  {
    return longitud;
  }

  // Valores
  // -------

  public int CodigoValor (String str)
  {
    return valores.CodigoValor (str);
  }

  // Dominios
  // --------

  // Creacin

  public void Dominio (String str)
  {
    dominios.NuevoValor (str);
  }

  // Consulta

  public Lista DominiosValor (String str)
  {
    return dominios.DominiosValor (str);
  }

  public int DominioValor (String str)
  {
    return dominios.DominioValor (str);
  }

  // Salida estndar
  // ---------------

  public void Print ()
  {
    System.out.println (id+" (CHAR "+longitud+")");
  }

  public void FullPrint ()
  {
    System.out.println (id+" (CHAR "+longitud+") ["+dominios.Total()+" dominios]");

    dominios.Print();
  }

}

