package fbg.util.db;

// Title:       TMiner
// Version:     1.0
// Copyright:   August 1998
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

import fbg.tda.*;

// Tupla
// -----

// Modelizacin de la tupla de una tabla (utilizando listas de dominios)

public class Tupla
{
  Lista attr[];

  // Constructor

  public Tupla (int atributos)
  {
    attr = new Lista[atributos];
  }

  public void Dominios (int atributo, Lista list)
  {
    attr[atributo] = list;
  }

  // Acceso a variables de instancia

  public int Columnas ()
  {
    return attr.length;
  }

  public Lista Atributo (int i)
  {
    return attr[i];
  }

  // Salida estndar

  private void PrintLista (Lista l)
  {
    NodoLista n = l.Inicio();
    Integer   dato;

    while (n!=l.Fin()) {

      dato = (Integer) l.Leer(n);
      System.out.print (dato);
      n = l.Siguiente(n);

      if (n!=l.Fin())
	 System.out.print("/");
    }
  }

  public void Print ()
  {
    int i;

    System.out.print ("(");

    for (i=0; i<attr.length; i++) {

	PrintLista(attr[i]);

	if (i<attr.length-1)
	   System.out.print(",");
    }

    System.out.println (")");
  }

}

/* -------------------------------------------------------------------------------------- */
