package fbg.util.db;

// Title:       TMiner
// Version:     1.2
// Copyright:   1999
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

import java.sql.*;
import java.util.Vector;

import fbg.util.math.Decimal;

// Valores
// -------
// Clase contenedora de valores

public class Valores
{
  Campo  campo;
  Vector valores;

  // Constructor

  public Valores (Campo c)
  {
    campo   = c;
    valores = new Vector();
  }

  public void NuevoValor (Object obj, int support)
  {
    valores.addElement ( new Valor(obj,support) );
  }

  // Informacin

  public int Total ()
  {
    return valores.size();
  }

  public Valor Valor (int i)
  {
    return (Valor) valores.elementAt(i);
  }

  // Valor correspondiente a un cdigo
  // ---------------------------------

  public Object ObjetoValor (int ID)
  {
    if (ID>=0 && ID<Total()) {

       return ((Valor)valores.elementAt(ID)).valor;

    } else {

       return null;

    }
  }

  // Cdigo correspondiente a un valor
  // ---------------------------------

  // CampoCHAR

  public int CodigoValor (String str)
  {
    int   i;
    Valor v;

    for (i=0; i<Total(); i++) {
        v = (Valor) valores.elementAt(i);

	if (str.equals((String)v.valor))
           return i;
    }

    return -1;
  }

  // CampoNUMBER

  public int CodigoValor (Decimal num)
  {
    double val  = num.doubleValue();
    int    i;
    Valor  v;

    for (i=0; i<Total(); i++) {
        v = (Valor) valores.elementAt(i);

	if (val==((Decimal)v.valor).doubleValue())
           return i;
    }

    return -1;
  }

  // Anlisis de los valores de un atributo
  // --------------------------------------

  public int Analisis ()
  {
    int       tuplas = 0;
    Statement SQL    = null;
    ResultSet val    = null;

    try {

        SQL = campo.tabla.acceso.createStatement();

        val = SQL.executeQuery ( "SELECT " + campo.id + ",COUNT(*)"
                               + " FROM " + campo.tabla.id
                               + " GROUP BY " + campo.id
                               + " ORDER BY " + campo.id );

        if (campo instanceof CampoCHAR) {

           String    obj;
           int       sup;

           while (val.next()) {

                 obj = val.getString(1);
                 sup = val.getInt(2);

                 if (obj!=null)
                    NuevoValor (obj,sup);

                 tuplas += sup;
           }

        } else if (campo instanceof CampoNUMBER) {

           Decimal obj;
           int     sup;

           while (val.next()) {

                 obj = new Decimal(val.getString(1)); 
                 sup = val.getInt(2);

                 if (obj!=null)
                    NuevoValor (obj,sup);

                 tuplas += sup;
           }

        }

        SQL = null;
	val = null;

        System.gc();

    } catch (SQLException e) {

        while (e != null) {
              System.out.println(e.getMessage());
              e = e.getNextException();
        }
    }

    return tuplas;
  }
}
