package rf.distance;

// Medida de distancia = Medida de disimilaridad

import rf.data.Pattern;
import rf.clustering.Cluster;

/**
 * Distance metrics = Dissimilarity measure
 */

public abstract class Distance
{
  // Constructor
  // public Distance (Dataset set)

  /**
   * Returns the distance between patterns,
   * i.e. the dissimilarity measure between patterns.
   */

  public abstract float distance (Pattern p, Pattern q);

  /**
   * Returns the distance
   * between a cluster (i.e. its centroid) and a pattern
   */

  public abstract float distance (Cluster c, Pattern p);

  /**
   * Returns the distance
   * between clusters (i.e. between their centroids)
   */

  public abstract float distance (Cluster c1, Cluster c2);
}