package rf.distance;

// Distancia eucldea al cuadrado

import rf.data.Dataset;
import rf.data.Pattern;
import rf.clustering.Cluster; 

/**
 *  Distance metrics (dissimilarity measure): Squared Euclidean distance
 */

public class EuclideanDistance extends Distance
{
  int noa;          // Nmero de atributos

  // Constructor

  public EuclideanDistance ( Dataset data )
  {
    noa = data.attributes();
  }

  // Distancia entre patrones
  // Mide la distancia de un patrn a otro (medida de disimilaridad)

  public float distance (Pattern p, Pattern q)
  {
    float diff;
    float d = 0;
    int   i;

    for (i=0; i<noa; i++) {
        diff  = p.attribute(i) - q.attribute(i);
        d    += diff*diff;
    }

    return d;
  }

  public float distance (Cluster c, Pattern p)
  {
    float diff;
    float d = 0;
    int   i;

    if (c.size()>0) {

       for (i=0; i<noa; i++) {
           diff  = c.centroid(i) - p.attribute(i);
           d    += diff*diff;
       }

    } else {

       d = 1e30f;
    }

    return d;
  }

  public float distance (Cluster c1, Cluster c2)
  {
    float diff;
    float d = 0;
    int   i;

    for (i=0; i<noa; i++) {
        diff  = c1.centroid(i) - c2.centroid(i);
        d    += diff*diff;
    }

    return d;
  }
}
