package rf.edit;

// Multiedicin

import fbg.util.Benchmark;

import rf.*;
import rf.data.*;


public class MultiEdit
{
  DataConfiguration cfg;
  Dataset           original;
  Dataset           result;

  int               noc;
  String            classes[];

  // Constructor

  public MultiEdit (DataConfiguration config, Dataset set, int m, int I)
  {
    this (config,set,m,I,100);
  }

  public MultiEdit (DataConfiguration config, Dataset set, int m, int I, int maxI)
  {
    int              i,t;
    Dataset          tmp;
    PartitionEdition pe;

    cfg      = config;
    original = set;
    noc      = cfg.totalClasses();
    classes  = cfg.getClasses();

    // Inicializacin

    result = original;
    i      = 0;
    t      = 0;

    // Bucle principal

    do {

       System.err.println(result.instances());

       pe  = new PartitionEdition (cfg,result,m,1);

       tmp = pe.getResult();

       if (tmp.instances()==result.instances()) {

          i ++;

       } else {

          result = tmp;
          i      = 0;
       }

       t++;

    } while (i<I && t<maxI);

  }

  // Conjunto de entrenamiento original

  public Dataset getOriginal ()
  {
    return original;
  }

  // Conjunto de entrenamiento editado

  public Dataset getResult ()
  {
    return result;
  }

  // TEST

  public static void main (String args[])
  {
    DataConfiguration   c     = null;
    Data                d     = null;
    Dataset             set   = null;
    int                 m,I;
    MultiEdit           edit  = null;
    Benchmark           crono = null;

    if (args.length<3) {

       System.out.println ("Sintaxis: MultiEdit <fichero_CFG> <m> <I> [<fichero_DAT>]");

    } else {

       c = new DataConfiguration (args[0]);

       if (c.totalClasses()<2 || c.totalAttributes()==0) {
          System.out.println ("Fichero CFG incorrecto");
          System.exit(1);
       }

       m = (new Integer(args[1])).intValue();
       I = (new Integer(args[2])).intValue();

       if (m<2)
          m = 2;

       if (I<1)
          I = 1;

       printStringArray ( c.getDescription() );

       d  = c.getData();

       System.out.println ();
       System.out.println ("- Clases: "+c.totalClasses());
       System.out.println ("- Atributos: "+c.totalAttributes());
       System.out.println ("- Conjunto de entrenamiento: "+d.learningInstances()+" patrones");
       System.out.println ("- Conjunto de prueba: "+d.testInstances()+" patrones");
       System.out.println ();

       if (args.length==4) {
          set = AsciiData.load (d, args[3]);
       } else {
          set = d.learningSet();
       }

       crono = new Benchmark();

       crono.start();

       edit = new MultiEdit (c, set, m, I);

       crono.stop();

       System.out.println ( "MULTIEDIT: "
                          + edit.getOriginal().instances()
                          + " ---> "
                          + edit.getResult().instances()
                          + " ("+crono+")" );

       AsciiData.save(edit.getResult(),"multiedit.dat");
    }
  }

  private static void printStringArray (String array[])
  {
    int i;

    if (array!=null)
       for (i=0; i<array.length; i++)
           System.out.println(array[i]);
  }

}