package rf.gui;

// Title:       Numerical Cruncher
// Version:     2.1
// Copyright:   January 1999
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import fbg.gui.*;

import fbg.util.Environment;

// v1.0 Jan'99 JDK 1.1 & SWING 1.0.1
// v2.0 Jan'99 JDK 1.2
// v2.1 May'99 Visualization

public class Dialog2INT extends Dialog
{
 String   id1;
 String   id2;

 Panel    panel         = new Panel();
 XYLayout xyLayout      = new XYLayout();
 JButton  jButtonOK     = new JButton();
 JButton  jButtonCancel = new JButton();
 Label    label1        = new Label();
 Label    label2        = new Label();

 // Sliders

 public JSlider jSlider1 = new JSlider();
 public JSlider jSlider2 = new JSlider();

 // OK button pressed ?

 public boolean ok;  

 // Constructor
 // -----------

 public Dialog2INT ( Frame frame,
                     String title,
                     boolean modal,
                     String v1,
                     String v2 )
 {
   super(frame, title, modal);

   id1 = v1;
   id2 = v2;

   enableEvents(AWTEvent.WINDOW_EVENT_MASK);

   try {
     jbInit();
     add(panel);
     pack();
   } catch (Exception ex) {
     ex.printStackTrace();
   }

   label1.setText (v1+" = "+int1());
   label2.setText (v2+" = "+int2());

   jButtonOK.setText("OK");

   if (Environment.settings==Environment.SPANISH) {
      jButtonOK.setToolTipText("Aceptar valores de "+id1+" y "+id2);
      jButtonCancel.setText("Cancelar");
   } else {
      jButtonOK.setToolTipText("Accept "+id1+" & "+id2+" values");
      jButtonCancel.setText("Cancel");
   }
 }


 public Dialog2INT (Frame frame, String title, String v1, String v2)
 {
  this(frame,title,true,v1,v2);
 }


 void jbInit() throws Exception
 {
  xyLayout.setHeight(160);
  xyLayout.setWidth(250);

  jButtonOK.addActionListener(new Dialog2INT_jButtonOK_actionAdapter(this));
  jButtonCancel.addActionListener(new Dialog2INT_jButtonCancel_actionAdapter(this));

  jSlider1.setValue(5);
  jSlider1.setMaximum(30);
  jSlider1.setMinimum(2);
  jSlider1.setMajorTickSpacing(4);
  jSlider1.setMinorTickSpacing(1);
  jSlider1.addChangeListener(new Dialog2INT_jSlider_changeAdapter(this));
  jSlider1.setPaintTicks(true);

  jSlider2.setValue(5);
  jSlider2.setMaximum(30);
  jSlider2.setMinimum(2);
  jSlider2.setMajorTickSpacing(4);
  jSlider2.setMinorTickSpacing(1);
  jSlider2.addChangeListener(new Dialog2INT_jSlider_changeAdapter(this));
  jSlider2.setPaintTicks(true);

  label1.setAlignment(1);
  label2.setAlignment(1);

  panel.setLayout(xyLayout);
  panel.add(jSlider1, new XYConstraints(0, 10, 250, -1));
  panel.add(label1, new XYConstraints(0, 40, 250, 20));
  panel.add(jSlider2, new XYConstraints(0, 65, 250, -1));
  panel.add(label2, new XYConstraints(0, 95, 250, 20));
  panel.add(jButtonOK, new XYConstraints(30, 125, 90, -1));
  panel.add(jButtonCancel, new XYConstraints(130, 125, 90, -1));
 }

 // Event handling

 protected void processWindowEvent(WindowEvent e)
 {
  if (e.getID() == WindowEvent.WINDOW_CLOSING) {
     dispose();
     ok = false;
  }

  super.processWindowEvent(e);
 }

 void jButtonOK_actionPerformed(ActionEvent e)
 {
   dispose();
   ok = true;
 }

 void jButtonCancel_actionPerformed(ActionEvent e)
 {
   dispose();
   ok = false;
 }

 void jSlider_stateChanged (ChangeEvent e)
 {
   label1.setText (id1+" = "+int1());
   label2.setText (id2+" = "+int2());
 }

 // Selected values

 public int int1 ()
 {
   return jSlider1.getValue();
 }

 public int int2 ()
 {
   return jSlider2.getValue();
 }
}

// Event handlers
// --------------

class Dialog2INT_jButtonOK_actionAdapter implements java.awt.event.ActionListener
{
 Dialog2INT adaptee;

 Dialog2INT_jButtonOK_actionAdapter (Dialog2INT adaptee)
 {
  this.adaptee = adaptee;
 }

 public void actionPerformed(ActionEvent e)
 {
  adaptee.jButtonOK_actionPerformed(e);
 }
}

class Dialog2INT_jButtonCancel_actionAdapter implements java.awt.event.ActionListener
{
 Dialog2INT adaptee;

 Dialog2INT_jButtonCancel_actionAdapter (Dialog2INT adaptee)
 {
  this.adaptee = adaptee;
 }

 public void actionPerformed(ActionEvent e)
 {
  adaptee.jButtonCancel_actionPerformed(e);
 }
}

class Dialog2INT_jSlider_changeAdapter implements javax.swing.event.ChangeListener
{
 Dialog2INT adaptee;

 Dialog2INT_jSlider_changeAdapter (Dialog2INT adaptee)
 {
  this.adaptee = adaptee;
 }

 public void stateChanged(ChangeEvent e)
 {
  adaptee.jSlider_stateChanged(e);
 }
}

