package rf.gui;

// Title:       Numerical Cruncher
// Version:     2.1
// Copyright:   1999
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import fbg.gui.*;

import fbg.util.Environment;

// v1.0  Jan'99  JDK 1.1 & SWING 1.0.1
// v2.0  Jan'99  JDK 1.2
// v2.1  May'99  Cancel

public class DialogApriori extends Dialog
{
 Panel     panel = new Panel();
 JButton   jButtonOK = new JButton();
 JButton   jButtonCancel = new JButton();
 JCheckBox jCheckBoxApriori = new JCheckBox();
 XYLayout  xyLayout = new XYLayout();

 // OK ?

 public boolean ok;

 // Constructor

 public DialogApriori(Frame frame, String title, boolean modal)
 {
   super(frame, title, modal);

   enableEvents(AWTEvent.WINDOW_EVENT_MASK);

   try {
     jbInit();
     add(panel);
     pack();
   } catch (Exception ex) {
     ex.printStackTrace();
   }

   jButtonOK.setText("OK");

   if (Environment.settings==Environment.SPANISH) {
      jButtonOK.setToolTipText("Aceptar seleccin");
      jButtonCancel.setText("Cancelar");
      jCheckBoxApriori.setText("Utilizar probabilidades a priori");
      jCheckBoxApriori.setToolTipText("Emplear la frecuencia de cada clase en el conjunto de entrenamiento");
   } else {
      jButtonOK.setToolTipText("Accept selection");
      jButtonCancel.setText("Cancel");
      jCheckBoxApriori.setText("Use apriori probabilities");
      jCheckBoxApriori.setToolTipText("Use class frequency in training dataset");
   }
 }

 public DialogApriori (Frame frame, String title)
 {
   this(frame, title, true);
 }

 void jbInit() throws Exception
 {
  jButtonOK.addActionListener(new DialogApriori_jButtonOK_actionAdapter(this));
  jButtonCancel.addActionListener(new DialogApriori_jButtonCancel_actionAdapter(this));

  xyLayout.setHeight(80);
  xyLayout.setWidth(220);

  panel.setLayout(xyLayout);
  panel.add(jCheckBoxApriori, new XYConstraints(15, 10, 190, 35));
  panel.add(jButtonOK, new XYConstraints(15, 45, 90, -1));
  panel.add(jButtonCancel, new XYConstraints(115, 45, 90, -1));
 }

 // Events

 protected void processWindowEvent(WindowEvent e)
 {
   if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      dispose();
      ok = false;
   }

   super.processWindowEvent(e);
 }

 void jButtonOK_actionPerformed(ActionEvent e)
 {
   dispose();
   ok = true;
 }

 void jButtonCancel_actionPerformed(ActionEvent e)
 {
   dispose();
   ok = false;
 }

 public boolean useAprioriProbabilities ()
 {
   return jCheckBoxApriori.isSelected();
 }
}

// Event handlers
// --------------

class DialogApriori_jButtonOK_actionAdapter implements java.awt.event.ActionListener
{
 DialogApriori adaptee;

 DialogApriori_jButtonOK_actionAdapter(DialogApriori adaptee)
 {
  this.adaptee = adaptee;
 }

 public void actionPerformed(ActionEvent e)
 {
  adaptee.jButtonOK_actionPerformed(e);
 }
}

class DialogApriori_jButtonCancel_actionAdapter implements java.awt.event.ActionListener
{
 DialogApriori adaptee;

 DialogApriori_jButtonCancel_actionAdapter(DialogApriori adaptee)
 {
  this.adaptee = adaptee;
 }

 public void actionPerformed(ActionEvent e)
 {
  adaptee.jButtonCancel_actionPerformed(e);
 }
}
