package rf.gui;

// Title:       Numerical Cruncher
// Version:     2.1
// Copyright:   1999
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import fbg.gui.*;

import fbg.util.Environment;

// v1.0  Jan'99  JDK 1.1 & SWING 1.0.1
// v2.0  Jan'99  JDK 1.2
// v2.1  May'99  Bug (jButtonOK "..." -> "OK") + Cancel JButton


public class DialogK extends Dialog
{
 Panel    panel         = new Panel();
 XYLayout xyLayout      = new XYLayout();
 JButton  jButtonOK     = new JButton();
 JButton  jButtonCancel = new JButton();
 Label    labelK        = new Label();

 // Slider

 public JSlider jSliderK = new JSlider();

 // OK button pressed ?

 public boolean ok;  

 // Constructor
 // -----------

 public DialogK(Frame frame, String title, boolean modal)
 {
   super(frame, title, modal);

   enableEvents(AWTEvent.WINDOW_EVENT_MASK);

   try {
     jbInit();
     add(panel);
     pack();
   } catch (Exception ex) {
     ex.printStackTrace();
   }

   labelK.setText ("K = "+K());
   jButtonOK.setText("OK");

   if (Environment.settings==Environment.SPANISH) {
      jButtonOK.setToolTipText("Aceptar valor de K");
      jButtonCancel.setText("Cancelar");
   } else {
      jButtonOK.setToolTipText("Accept K value");
      jButtonCancel.setText("Cancel");
   }
 }

 public DialogK(Frame frame, String title)
 {
  this(frame, title, true);
 }

 void jbInit() throws Exception
 {
  xyLayout.setHeight(110);
  xyLayout.setWidth(250);
  
  jButtonOK.addActionListener(new DialogK_jButtonOK_actionAdapter(this));
  jButtonCancel.addActionListener(new DialogK_jButtonCancel_actionAdapter(this));

  jSliderK.setValue(5);
  jSliderK.setMaximum(30);
  jSliderK.setMinimum(2);
  jSliderK.setMajorTickSpacing(4);
  jSliderK.setMinorTickSpacing(1);
  jSliderK.addChangeListener(new DialogK_jSliderK_changeAdapter(this));
  jSliderK.setPaintTicks(true);
  
  labelK.setAlignment(1);
  
  panel.setLayout(xyLayout);
  panel.add(jSliderK, new XYConstraints(25, 14, 200, -1));
  panel.add(labelK, new XYConstraints(90, 50, 70, -1));
  panel.add(jButtonOK, new XYConstraints(30, 78, 90, -1));
  panel.add(jButtonCancel, new XYConstraints(130, 78, 90, -1));
 }

 // Events

 protected void processWindowEvent(WindowEvent e)
 {
  if (e.getID() == WindowEvent.WINDOW_CLOSING) {
     dispose();
     ok = false;
  }

  super.processWindowEvent(e);
 }

 void jButtonOK_actionPerformed(ActionEvent e)
 {
   dispose();
   ok = true;
 }

 void jButtonCancel_actionPerformed(ActionEvent e)
 {
   dispose();
   ok = false;
 }

 void jSliderK_stateChanged (ChangeEvent e)
 {
   labelK.setText ("K = "+K());
 }

 public int K ()
 {
   return jSliderK.getValue();
 }

}


// Event handlers
// --------------

class DialogK_jButtonOK_actionAdapter implements java.awt.event.ActionListener
{
 DialogK adaptee;

 DialogK_jButtonOK_actionAdapter(DialogK adaptee)
 {
  this.adaptee = adaptee;
 }

 public void actionPerformed(ActionEvent e)
 {
  adaptee.jButtonOK_actionPerformed(e);
 }
}

class DialogK_jButtonCancel_actionAdapter implements java.awt.event.ActionListener
{
 DialogK adaptee;

 DialogK_jButtonCancel_actionAdapter(DialogK adaptee)
 {
  this.adaptee = adaptee;
 }

 public void actionPerformed(ActionEvent e)
 {
  adaptee.jButtonCancel_actionPerformed(e);
 }
}

class DialogK_jSliderK_changeAdapter implements javax.swing.event.ChangeListener
{
 DialogK adaptee;

 DialogK_jSliderK_changeAdapter(DialogK adaptee)
 {
  this.adaptee = adaptee;
 }

 public void stateChanged(ChangeEvent e)
 {
  adaptee.jSliderK_stateChanged(e);
 }
}

