package rf.gui;

// Title:       Numerical Cruncher
// Version:     1.1
// Copyright:   December 1998 - June 1999
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

import java.awt.*;
import java.awt.event.*;
import java.awt.image.MemoryImageSource;

import fbg.util.*;

import rf.data.*;

/**
 * <p>
 * Image viewer
 *
 * @version 1.1
 * @author  Fernando Berzal Galiano
 * @see     rf.data.ImageBand
 */

// v1.0 December 1998
// v1.1 June     1999 (icon)

public class FrameImage extends Frame
{
  ImageComponent img = null;
  int            dim = 300;

  // Constructor

  public FrameImage (Image image, String title, int dim)
  {
    if (image!=null)
       img = new ImageComponent(image);

    try {

      Image icon = Loader.loadImage(getClass(),"image/figure.gif");

      this.setIconImage(icon);
      this.setTitle(title);
      this.setBackground(Color.lightGray);
      this.addWindowListener(new FrameImage_this_windowAdapter(this));
      this.setSize(dim,dim);

      if (img!=null)
         this.add (img);

    } catch (Exception e) {
      e.printStackTrace();
    }
  }

  // Window closing
  // --------------

  void this_windowClosing(WindowEvent e)
  {
    dispose();
  }
}

// Auxiliary Component
// -------------------

class ImageComponent extends Canvas
{
  Image img = null;

  public ImageComponent (Image imagen)
  {
    img = imagen;
  }

  public void paint (Graphics g)
  {
    if (img!=null) {

       Dimension d = getSize();

       // g.setXORMode(Color.white);
       // g.setXORMode(Color.black);
       // setBackground(Color.black);
       // g.setColor(Color.black);
       g.drawImage (img, (d.width-img.getWidth(null))/2, (d.height-img.getHeight(null))/2,this);

       // g.drawImage (img, x,y, anchura,altura, this);
       // g.drawImage (img, x,y, this);
    }
  }
}


// Event handling
// --------------

class FrameImage_this_windowAdapter extends java.awt.event.WindowAdapter
{
  FrameImage adaptee;

  FrameImage_this_windowAdapter(FrameImage adaptee)
  {
    this.adaptee = adaptee;
  }

  public void windowClosing(WindowEvent e)
  {
    adaptee.this_windowClosing(e);
  }
}

