package rf.gui;

// Title:       Numerical Cruncher
// Version:     1.0
// Copyright:   January 1999
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

import java.io.*;
import java.awt.*;


public class Logo extends Canvas
{
  Image img = null;

  public Logo ()
  {
    // img = Toolkit.getDefaultToolkit().getImage ( "image/ugr.gif" );

    byte[] imageData = loadResource(getClass(),"image/logo.gif");

    img = Toolkit.getDefaultToolkit().createImage(imageData);
  }


  public byte[] loadResource(final Class baseClass, String file)
  {
    byte[] buffer = null;

    try {
          /* Copy resource into a byte array.  This is
           * necessary because several browsers consider
           * Class.getResource a security risk because it
           * can be used to load additional classes.
           * Class.getResourceAsStream just returns raw
           * bytes, which we can convert to an image.
           */

      InputStream resource = baseClass.getResourceAsStream(file);

      if (resource == null) {
         System.err.println(baseClass.getName() + "/" + file + " not found.");
         return null;
      }

      BufferedInputStream   in  = new BufferedInputStream(resource);
      ByteArrayOutputStream out = new ByteArrayOutputStream(1024);

      buffer = new byte[1024];

      int n;

      while ((n = in.read(buffer)) > 0) {
            out.write(buffer, 0, n);
      }

      in.close();
      out.flush();

      buffer = out.toByteArray();

      if (buffer.length == 0) {
          System.err.println("Warning: " + file + " is zero-length");
          return null;
      }

    } catch (IOException ioe) {
       System.err.println(ioe.toString());
       return null;
    }

    return buffer;
  }


  public void paint (Graphics g)
  {
    if (img!=null) {

       Dimension d = getSize();

       g.drawImage (img, (d.width-img.getWidth(null))/2, (d.height-img.getHeight(null))/2,this);

       // g.drawImage (img, x,y, anchura,altura, this);
       // g.drawImage (img, x,y, this);
    }
  }
}
